Subject: bug#32234: [PATCH 2/2] database: Serialize all database accesses in a thread.

From: [email-masked] (Ludovic Courtès)
Date: Sun, 26 Aug 2018 23:16:23 +0200

Hi Clément,

Clément Lassieur <[email-masked]> skribis:

> Ludovic Courtès <[email-masked]> writes:
>
>> Excellent, thanks for working on this!  This looks great to me, and I
>> think the pros outweigh the cons.  Did you check on a big database how
>> well it performs?
>
> Yes, I didn't see any difference.  When I use Berlin's database, it
> works well but crashes quickly for another reason (lack of disk space I
> think, and /tmp being tmpfs).

Sounds good (not that it crashes, but that you didn’t see any
difference ;-)).

>> I think I find it nicer to keep the ‘db’ parameter everywhere (except
>> that it’s now a channel instead of an actual database) rather than using
>> this global variable.
>>
>> WDYT?
>
> That 'db' parameter made sense before, because there were different
> database connections: one per fiber.  But now that there is only one
> global channel accessible from everywhere, I can't find any use for a
> 'db-channel' parameter.
>
> Also, using two differents channels for the same database would be a
> bug, it would break the serialization mechanism.
>
> And I don't think using several databases (with one channel per
> database) would make sense either.

These are all good points, indeed.  I’m mildly reluctant to the global
parameter, but if you prefer it that way, I don’t mind; the end result
matters more than this tiny issue anyway!

So: LGTM.

Thank you!

Ludo’.